"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_tools_1 = require("graphql-tools");
var merge_typedefs_1 = require("./typedefs-mergers/merge-typedefs");
var helpers_1 = require("../utils/helpers");
var merge_resolvers_1 = require("./resolvers-mergers/merge-resolvers");
var utils_1 = require("../utils");
function mergeSchemas(_a) {
    var schemas = _a.schemas, typeDefs = _a.typeDefs, resolvers = _a.resolvers, resolversComposition = _a.resolversComposition, schemaDirectives = _a.schemaDirectives, resolverValidationOptions = _a.resolverValidationOptions, logger = _a.logger;
    return graphql_tools_1.makeExecutableSchema({
        typeDefs: merge_typedefs_1.mergeTypeDefs(schemas.concat(typeDefs ? helpers_1.asArray(typeDefs) : [])),
        resolvers: utils_1.composeResolvers(merge_resolvers_1.mergeResolvers(schemas.map(function (schema) { return utils_1.extractResolversFromSchema(schema); }).concat(resolvers ? helpers_1.asArray(resolvers) : [])), resolversComposition || {}),
        schemaDirectives: schemaDirectives,
        resolverValidationOptions: resolverValidationOptions,
        logger: logger
    });
}
exports.mergeSchemas = mergeSchemas;
//# sourceMappingURL=merge-schemas.js.map